#include "Concat.hpp"

ConcatImpl::ConcatImpl(int inputSize, int outputSize) : inputSize(inputSize), outputSize(outputSize)
{
  dimReduce = register_module("dimReduce", torch::nn::Linear(inputSize, outputSize));
}

torch::Tensor ConcatImpl::forward(torch::Tensor input)
{
  return dimReduce(input).view({input.size(0), -1});
}

int ConcatImpl::getOutputSize(int sequenceLength)
{
  return sequenceLength * outputSize;
}

